﻿using UnityEngine;
using System.Collections;

public class Artifact : MonoBehaviour {

	public enum ArtifactType
	{
		Personal,
		Cultural,
		Wealth
	}

	public ArtifactType type;
	public int group;
	public Vector3 collectedScale;
	public Vector3 throwOffset;
	public Vector3 throwSpeed;

	private ArtifactCollector _collector;
	private Vector3 _worldScale;

	// Use this for initialization
	void Start () {
		_collector =  GameObject.FindGameObjectWithTag( "ArtifactCollector" ).GetComponent<ArtifactCollector>();
		_worldScale = transform.localScale;
	}
	
	// Update is called once per frame
	void Update () {
		if ( Input.GetMouseButtonDown ( 0 ) )
		{
			
			RaycastHit hitInfo;
			if ( Physics.Raycast( _collector.transform.position, _collector.transform.forward, out hitInfo, 5f ) )
			{
				if ( hitInfo.collider.gameObject == gameObject )
				{
					Debug.Log( "mousedown" );
					Artifact oldArtifact = _collector.artifacts [ group ];
					if ( oldArtifact != null )
					{
						oldArtifact.GetComponent<Rigidbody>().useGravity = true;
						oldArtifact.GetComponent<Rigidbody>().isKinematic = false;
						oldArtifact.GetComponent<BoxCollider>().isTrigger = false;
						oldArtifact.transform.localScale = oldArtifact._worldScale;
						oldArtifact.transform.SetParent( null );
						oldArtifact.transform.position = _collector.throwStart.TransformPoint( throwOffset );
						oldArtifact.GetComponent<Rigidbody>().velocity = _collector.throwStart.TransformDirection( throwSpeed );
					}

					_collector.artifacts [ group ] = this;
					transform.SetParent( _collector.transform );
					transform.localPosition = _collector.collectedSlots [ group ];
					transform.localRotation = Quaternion.LookRotation ( -Vector3.forward );
					transform.localScale = collectedScale;
					transform.GetComponent<Rigidbody>().useGravity = false;
					transform.GetComponent<Rigidbody>().isKinematic = true;
					transform.GetComponent<BoxCollider>().isTrigger = true;
				}
			}
		}
	}
}
