﻿using UnityEngine;
using System.Collections;

public class Rocket : MonoBehaviour {

	public int artifactsRequired = 0;

	public string levelNamePersonal;
	public string levelNameCultural;
	public string levelNameWealth;
	public string levelNamePersonalCultural;
	public string levelNameCulturalWealth;
	public string levelNameWealthPersonal;

	private ArtifactCollector _collector;

	// Use this for initialization
	void Start () {
		_collector = GameObject.FindGameObjectWithTag( "ArtifactCollector" ).GetComponent<ArtifactCollector>();
	}

	private void AddLevel ( string argLevelName )
	{
		if ( artifactsRequired == 1 )
		{
			GameObject oldPlayer = GameObject.FindGameObjectWithTag( "Player" );

			Application.LoadLevelAdditive( argLevelName );

			GameObject [] oldPlayers = GameObject.FindGameObjectsWithTag( "Player" );
			foreach ( GameObject testPlayer in oldPlayers )
			{
				if ( testPlayer != oldPlayer )
				{
					oldPlayer.transform.position = testPlayer.transform.position;
					oldPlayer.transform.rotation = testPlayer.transform.rotation;
					GameObject.Destroy( testPlayer );
					break;
				}
			}
		}
		else
		{
			Application.LoadLevel( argLevelName );
		}
	}
	
	// Update is called once per frame
	void Update () {
		if ( Input.GetMouseButtonDown ( 0 ) )
		{
			RaycastHit hitInfo;

			if ( Physics.Raycast( _collector.transform.position, _collector.transform.forward, out hitInfo, 10f ) )
			{
				if ( hitInfo.collider.gameObject == gameObject )
				{
					if ( _collector.collected >= artifactsRequired )
					{
						switch ( _collector.artifacts [ 0 ].type )
						{
							case Artifact.ArtifactType.Personal:
								// personal
								if ( artifactsRequired == 1 || _collector.artifacts [ 1 ].type == Artifact.ArtifactType.Personal )
								{
									AddLevel( levelNamePersonal );
								}
								else if ( _collector.artifacts [ 1 ].type == Artifact.ArtifactType.Cultural )
								{
									AddLevel( levelNamePersonalCultural );
								}
								else
								{
									AddLevel( levelNameWealthPersonal );
								}
								break;
							case Artifact.ArtifactType.Cultural:
								// cultural
								if ( artifactsRequired == 1 || _collector.artifacts [ 1 ].type == Artifact.ArtifactType.Cultural )
								{
									AddLevel( levelNameCultural );
								}
								else if ( _collector.artifacts [ 1 ].type == Artifact.ArtifactType.Personal )
								{
									AddLevel( levelNamePersonalCultural );
								}
								else
								{
									AddLevel( levelNameCulturalWealth );
								}
								break;
							case Artifact.ArtifactType.Wealth:
								// wealth
								if ( artifactsRequired == 1 || _collector.artifacts [ 1 ].type == Artifact.ArtifactType.Wealth )
								{
									AddLevel( levelNameWealth );
								}
								else if ( _collector.artifacts [ 1 ].type == Artifact.ArtifactType.Personal )
								{
									AddLevel( levelNameWealthPersonal );
								}
								else
								{
									AddLevel( levelNameCulturalWealth );
								}
								break;
						}
						}
				}
			}
		}
	}
}
